/* Copyright (c) 1997-2008
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ident "$Project: polymake $$Id: altshuler_det.cc 8969 2008-12-05 15:54:42Z gawrilow $"

#include <Rational.h>
#include <IncidenceMatrix.h>
#include <SparseMatrix.h>
#include <linalg.h>
#include <polymake.h>

namespace polymake { namespace graph {

Integer altshuler_det(const IncidenceMatrix<>& Inc)
{
   return Inc.rows() <= Inc.cols()
          ? det( same_element_sparse_matrix<Integer>(Inc) * T(same_element_sparse_matrix<Integer>(Inc)) )
          : det( T(same_element_sparse_matrix<Integer>(Inc)) * same_element_sparse_matrix<Integer>(Inc) );
}

Function4perl(&altshuler_det, "altshuler_det");

} }

