/* Copyright (c) 1997-2007
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ident "$Project: polymake $$Id: bipartite.cc 7773 2007-10-25 23:14:10Z gawrilow $"

/*  @author Niko Witte <witte@math.tu-berlin.de>  */

#include <bipartite.h>
#include <Graph.h>
#include <perl/Object.h>

namespace polymake { namespace graph {

   void bipartite(perl::Object p)
   {
      const Graph<> G=p.give("ADJACENCY");
      const int sign=bipartite_sign(G);
      p.take("BIPARTITE") << (sign>=0);
      p.take("SIGNATURE") << sign;
   }

   Function4perl(&bipartite, "bipartite");
} }
