/* Copyright (c) 1997-2007
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ident "$Project: polymake $$Id: cdd_ch_client.cc 7904 2008-01-23 16:03:19Z gawrilow $"

#include <ch_client.h>
#include <cdd_interface.h>

namespace polymake { namespace polytope {

template <typename Scalar>
void cdd_ch_primal(perl::Object p)
{
   cdd_interface::solver<Scalar> solver;
   ch_primal(p, solver);
}

template <typename Scalar>
void cdd_ch_dual(perl::Object p)
{
   cdd_interface::solver<Scalar> solver;
   ch_dual(p, solver);
}

FunctionTemplate4perl("cdd_ch_primal<Scalar> (Polytope<Scalar>) : void");
FunctionTemplate4perl("cdd_ch_dual<Scalar> (Polytope<Scalar>) : void");

} }
