/* Copyright (c) 1997-2007
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ident "$Project: polymake $$Id: lrs_redund_client.cc 7858 2008-01-02 22:33:38Z gawrilow $"

#include <polymake.h>
#include <Rational.h>
#include <lrs_interface.h>

namespace polymake { namespace polytope {

void lrs_eliminate_redundant_points(perl::Object p)
{
   lrs_interface::solver solver;
   const Matrix<Rational> P=p.give("POINTS");
   const lrs_interface::solver::non_redundant V=solver.find_vertices_among_points(P);
   p.take("VERTICES") << P.minor(V.first,All);
   p.take("AFFINE_HULL") << V.second;
}

Function4perl(&lrs_eliminate_redundant_points, "lrs_eliminate_redundant_points(Polytope<Rational>)");

} }
