/* Copyright (c) 1997-2008
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _POLYMAKE_HASH_ITERATORS_H
#define _POLYMAKE_HASH_ITERATORS_H "$Project: polymake $$Id: hash_iterators.h 8863 2008-10-24 22:56:00Z gawrilow $"

#if __GNUC__==4 && (__GNUC_MINOR__==2 || __GNUC_MINOR__==3)
#  define PM_TR1_HashtableIterator      std::tr1::__detail::_Hashtable_iterator
#  define PM_TR1_HashtableConstIterator std::tr1::__detail::_Hashtable_const_iterator
#else
/* not known yet */
#endif

namespace pm {

template <typename Value, bool __constant_iterators, bool __cache>
struct iterator_cross_const_helper< PM_TR1_HashtableIterator<Value,__constant_iterators,__cache>, true> {
   typedef PM_TR1_HashtableIterator<Value,__constant_iterators,__cache> iterator;
   typedef PM_TR1_HashtableConstIterator<Value,__constant_iterators,__cache> const_iterator;
};

template <typename Value, bool __constant_iterators, bool __cache>
struct iterator_cross_const_helper< PM_TR1_HashtableConstIterator<Value,__constant_iterators,__cache>, true> {
   typedef PM_TR1_HashtableIterator<Value,__constant_iterators,__cache> iterator;
   typedef PM_TR1_HashtableConstIterator<Value,__constant_iterators,__cache> const_iterator;
};

} // end namespace pm

#undef PM_TR1_HashtableIterator
#undef PM_TR1_HashtableConstIterator

#endif // _POLYMAKE_HASH_ITERATORS_H

// Local Variables:
// mode:C++
// End:
