/* Copyright (c) 1997-2008
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Berlin, Germany)
   http://www.math.tu-berlin.de/polymake,  mailto:polymake@math.tu-berlin.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
*/

#ifndef _POLYMAKE_PERL_MACROS_H
#define _POLYMAKE_PERL_MACROS_H "$Project: polymake $$Id: macros.h 8414 2008-09-04 15:21:25Z gawrilow $"

/* The following macros are designed to be used in the files automatically generated by polymake.
   If you use them in the manually written code, you are doing it on your own risk!

   The changes in syntax and contents must be coordinated with the corresponding routines
   in the package Poly::CPlusPlus
*/

#define StaticRegistrator4perl \
   template <typename What, int id> \
   class StAtIcReG { public: static What r; }

#define Class4perl(pkg,...) \
template<> polymake::perl_bindings::Class< __VA_ARGS__ > StAtIcReG<polymake::perl_bindings::Class< __VA_ARGS__ >,__LINE__>::r(pkg)

#define Builtin4perl(pkg,...) \
template<> pm::perl::Builtin< __VA_ARGS__ > StAtIcReG<pm::perl::Builtin< __VA_ARGS__ >,__LINE__>::r(pkg)

#define ClassTemplate4perl(pkg) \
template<> pm::perl::ClassTemplate StAtIcReG<pm::perl::ClassTemplate,__LINE__>::r(pkg)

#define implFunctionInstance4perl(...) \
template<> __VA_ARGS__ StAtIcReG<__VA_ARGS__,__LINE__>::r(__FILE__,0)

#define implMethodInstance4perl(first_arg_name,...) \
template<> __VA_ARGS__ StAtIcReG<__VA_ARGS__,__LINE__>::r(__FILE__,first_arg_name)

#define FirstArgAsString(first_arg_name,...) #first_arg_name

#define FunctionInstance4perl(f_class,...) implFunctionInstance4perl(Wrapper4perl_##f_class< __VA_ARGS__ >)
#define MethodInstance4perl(f_class,...) implMethodInstance4perl(FirstArgAsString(__VA_ARGS__), Wrapper4perl_##f_class< __VA_ARGS__ >)
#define OperatorInstance4perl(op_class,...) implFunctionInstance4perl(pm::perl::Operator_##op_class< __VA_ARGS__ >)

#define DisabledFunction4perl(name,...) \
template<> pm::perl::DisabledFunction<pm::list(__VA_ARGS__)> StAtIcReG<pm::perl::DisabledFunction<pm::list(__VA_ARGS__)>,__LINE__>::r(#name,__FILE__)

#define WrapperStart(name,perlname,...)				\
struct name {							\
   typedef pm::list arg_list(__VA_ARGS__);			\
   template <size_t fl, typename first_arg_type>		\
      name(const char (&file)[fl], first_arg_type arg0) { pm::perl::WrapperBase<name>::register_it(perlname,file,arg0); } \
   static SV* call(SV **stack __attribute__((unused)), char *frame_upper_bound __attribute__((unused)) )

#define FunctionInterface4perl(name,...) WrapperStart(Wrapper4perl_##name, #name, __VA_ARGS__)

// only pre-declare the call method, as it has to be specialized for each func pointer separately
#define defFunctionWrapper					\
template <typename Fptr>					\
struct perlFunctionWrapper {					\
   template <size_t fl>						\
   perlFunctionWrapper(const char (&file)[fl])			\
   {								\
      pm::perl::pm_perl_register_func((pm::perl::wrapper_type)&call, ".wrp", 4, file, fl-1, pm::perl::TypeListUtils<Fptr>::get_types(), 0, 0); \
   }								\
   typedef Fptr *fptr_type;					\
   static SV* call(fptr_type, SV**, char*);			\
}

#define FunctionWrapper4perl(...) \
   template <>			  \
   SV* perlFunctionWrapper<__VA_ARGS__>::call(fptr_type func, SV **stack __attribute__((unused)), char *frame_upper_bound __attribute__((unused)) )

#define FunctionWrapperInstance4perl(...) \
template<> perlFunctionWrapper<__VA_ARGS__> StAtIcReG<perlFunctionWrapper<__VA_ARGS__>,__LINE__>::r(__FILE__)

#define WrapperCloseFunction } enum { _unused }

#define WrapperEpilogue(ret)			\
      catch (const std::exception& ex) {	\
	 return pm::perl::propagate(ex);	\
      }						\
      catch (...) {				\
	 return pm::perl::propagate();		\
      }						\
      return (ret)

#define WrapperBodyWithValue(pkg,fup,expr)		     \
      perl::Value ret(pm::perl::value_allow_non_persistent); \
      try {						     \
	 ret.put(expr, fup, pkg);			     \
      }							     \
      WrapperEpilogue(ret.get_temp())

#define WrapperBodyWithLvalue(pkg,Type,expr)				\
      perl::Value ret(pm::perl::value_flags(pm::attrib<typename pm::perl::access<Type>::type>::is_const \
					    ? pm::perl::value_expect_lval | pm::perl::value_allow_non_persistent | pm::perl::value_read_only \
					    : pm::perl::value_expect_lval | pm::perl::value_allow_non_persistent)); \
      try {								\
	 ret.put_lval(expr, arg0.get(), frame_upper_bound, pkg);	\
      }									\
      WrapperEpilogue(ret.get());					\
   WrapperCloseFunction

#define WrapperBodyWithoutValue(expr) \
      try { expr; }		      \
      WrapperEpilogue(0)

#define IndirectWrapperReturn(...)     WrapperBodyWithValue(0,frame_upper_bound,func(__VA_ARGS__))
#define IndirectWrapperReturnVoid(...) WrapperBodyWithoutValue(func(__VA_ARGS__))

#define WrapperReturnPkg(expr)     WrapperBodyWithValue(stack[0],frame_upper_bound,expr);   WrapperCloseFunction
#define WrapperReturn(expr)        WrapperBodyWithValue(0,frame_upper_bound,expr);          WrapperCloseFunction
#define WrapperReturnTmpPkg(expr)  WrapperBodyWithValue(stack[0],0,expr);                   WrapperCloseFunction
#define WrapperReturnTmp(expr)     WrapperBodyWithValue(0,0,expr);                  	    WrapperCloseFunction
#define WrapperReturnVoid(expr)	   WrapperBodyWithoutValue(expr);                           WrapperCloseFunction

#define WrapperReturnLvaluePkg(Type,expr)  WrapperBodyWithLvalue(stack[0],Type,expr)
#define WrapperReturnLvalue(Type,expr)     WrapperBodyWithLvalue(0,Type,expr)

#define WrapperReturnNew(Type, ...) \
      perl::Value ret;		    \
      try {			    \
	 new(ret.allocate<Type>()) Type __VA_ARGS__;	\
      }							\
      WrapperEpilogue(ret.get_temp());			\
   WrapperCloseFunction

#define Wrapper4UnaryOperator(sign,name)		 \
template <typename Arg0>				 \
WrapperStart( Operator_Unary_##name, "." #name, Arg0 ) { \
   Value arg0(stack[0]);				 \
   WrapperReturn( sign( arg0.get<Arg0>() ) );		 \
}

#define Wrapper4UnaryAssignOperator(sign,name)		       \
template <typename Arg0>				       \
WrapperStart( Operator_UnaryAssign_##name, "." #name, Arg0 ) { \
   Value arg0(stack[0]);				       \
   WrapperReturnLvalue( Arg0, sign( arg0.get<Arg0>() ) );      \
}

#define Wrapper4BinaryOperator(sign,name)		       \
template <typename Arg0, typename Arg1>			       \
WrapperStart( Operator_Binary_##name, ":" #name, Arg0,Arg1 ) { \
   Value arg0(stack[0]), arg1(stack[1]);		       \
   WrapperReturn( arg0.get<Arg0>() sign arg1.get<Arg1>() );    \
}

#define Wrapper4BinaryAssignOperator(sign,name)				\
template <typename Arg0, typename Arg1>					\
WrapperStart( Operator_BinaryAssign_##name, "=" #name, Arg0,Arg1 ) {	\
   Value arg0(stack[0]), arg1(stack[1]);				\
   WrapperReturnLvalue( Arg0, arg0.get<Arg0>() sign arg1.get<Arg1>() );	\
}


#define DeclareEmbeddedFunction(pre,fptr,decl,post) \
template<> \
pm::perl::Function StAtIcReG<pm::perl::Function,__LINE__>::r(fptr,__FILE__,__LINE__, pre " " decl " : c++ (embedded=>%d);\n" post)

#define Function4perl(fptr,decl)          DeclareEmbeddedFunction(            "function",fptr,decl,"")
#define UserFunction4perl(help,fptr,decl) DeclareEmbeddedFunction(help "\nuser_function",fptr,decl,"")
#define Method4perl(fptr,scope,decl)          DeclareEmbeddedFunction(scope " {\n\nmethod",fptr,decl,"}\n")
#define UserMethod4perl(help,fptr,scope,decl) DeclareEmbeddedFunction(scope " {\n\n" help "\nuser_method",fptr,decl,"}\n")

#define InsertEmbeddedRule(text) \
template<> \
pm::perl::EmbeddedRule StAtIcReG<pm::perl::EmbeddedRule,__LINE__>::r(__FILE__,__LINE__,text)

#define FunctionTemplate4perl(decl)          InsertEmbeddedRule("function " decl " : c++;\n")
#define UserFunctionTemplate4perl(help,decl) InsertEmbeddedRule(help "\nuser_function " decl " : c++;\n")
#define MethodTemplate4perl(scope,decl)          InsertEmbeddedRule(scope " {\n\nmethod " decl " : c++;\n}\n")
#define UserMethodTemplate4perl(help,scope,decl) InsertEmbeddedRule(scope " {\n\n" help "\nuser_method " decl " : c++;\n}\n")

#define OpaqueClass4perl(pkg,name,methods)		\
Class4perl(POLYMAKE_APPLICATION_PKG pkg,name*);		\
InsertEmbeddedRule("declare property_type " pkg " : c++ (special=>'" #name "') {\n" methods "}\n")

#define OpaqueMethod4perl(decl) "\nmethod " decl " : c++;\n"

#endif // _POLYMAKE_MACROS_H

// Local Variables:
// mode:C++
// End:
